import { Grammar } from "../grammar.js";
import { tmrTokenZIndex } from "../tmr-constants.js";
import { COORD_TMR_INCONNU, TMRUtility } from "../tmr-utility.js";
import { Draconique } from "./draconique.js";

export class QueteEaux extends Draconique {

  type() { return 'tete' }
  match(item) { return Draconique.isTeteDragon(item) && Grammar.toLowerCaseNoAccent(item.name).includes("quete des eaux"); }
  manualMessage() { return "Vous devrez re-configurer votre Nouvelle Quête des Eaux une fois un lac ou marais vaincu" }
  async onActorCreateOwned(actor, tete) {
    await this.createCaseTmr(actor, "Nouvelle Quête des Eaux", { coord: COORD_TMR_INCONNU }, tete.id);
  }

  code() { return 'maitrisee' }
  tooltip(linkData) {
    return linkData.system.coord == COORD_TMR_INCONNU ? 'Nouvelle Quête des eaux en cours' : `Quête des eaux, ${TMRUtility.getTMRType(linkData.system.coord)} maîtrisé`
  }
  img() { return 'systems/foundryvtt-reve-de-dragon/icons/tmr/maitrisee.svg' }

  createSprite(pixiTMR) {
    return pixiTMR.sprite(this.code(), {
      zIndex: tmrTokenZIndex.casehumide + 1,
      decallage: pixiTMR.sizes.decallage(0, -2 / 3),
      taille: () => pixiTMR.sizes.half
    });
  }
}
